local CAM_SPEED = 10

camera = {}

local altPressed, enterPressed = false
function camera.keypressed(key, _)
	if key == "return" then enterPressed = true end
	if key == "lalt" then altPressed = true end
	if key == "f11" or (altPressed and key == "return") or (enterPressed and key == "lalt") then
		fullscreen = not fullscreen
		love.window.setFullscreen(fullscreen, "desktop")
	end
end


function camera.keyreleased(key, _)
	if key == "lalt" then
		altPressed = false
	end
	if key == "return" then
		enterPressed = false
	end
	local change = false
	if key == "-" or key == "kp-" or key == "pagedown" then
		ui.update_scale(scale * 0.5)
		change = true
	end
	if key == "+" or key == "kp+" or key == "pageup" then
		ui.update_scale(scale * 2)
		change = true
	end
	if key == "kp0" then
		scale = 1
		change = true
	end
	if scale < 0.125 then ui.update_scale(0.125) change = false end
	if scale > 8 then ui.update_scale(8) change = false end
	if change then camera.setplayer() end
end


function camera.input(dt)
	-- TODO: rewrite for scale, so player always remains in view at max distance
	-- direct view control
	if love.keyboard.isDown("left") then
		view.x = view.x + dt * 300
	end
	if love.keyboard.isDown("right") then
		view.x = view.x - dt * 300
	end
	if love.keyboard.isDown("up") then
		view.y = view.y + dt * 300
	end
	if love.keyboard.isDown("down") then
		view.y = view.y - dt * 300
	end
end


function camera.resize()
		camera.setplayer()
end


function camera.setplayer()
	local perfectx = math.floor(player.x * -1) + ((window.x -300)/2 -((player.ava:getWidth() /2) / scale)) / scale
	local perfecty = math.floor(player.y * -1) + (window.y/2 -((player.ava:getHeight() /2) / scale)) / scale

	view.x = perfectx
	view.y = perfecty
end


function camera.update()
	--[[ Update camera to track player ]]--
	local perfectx = math.floor(player.x * -1)  + ((window.x -300)/2 -(player.ava:getWidth() /2)) / scale
	local perfecty = math.floor(player.y * -1)  + (window.y/2 -(player.ava:getHeight() /2)) / scale

	local deltax = (perfectx - view.x) / scale
	local deltay = (perfecty - view.y) / scale
	view.x = view.x + (deltax /(CAM_SPEED / (scale * scale)))
	view.y = view.y + (deltay /(CAM_SPEED / (scale * scale)))
end
