drawing = {}
drawing.currentCursor = love.graphics.newImage("textures/blocks/krock/Glass/3.png")
drawing.currentCursorName = "textures/blocks/krock/Glass/3.png"

function alignToGrid(num, thing)
	return math.floor(num / thing) * thing
end


function drawing.clearAllCanvases()
	love.graphics.setCanvas(buffer.pixel.fg)
		love.graphics.clear()
	love.graphics.setCanvas(buffer.pixel.bg)
		love.graphics.clear()
	love.graphics.setCanvas(buffer.pixel.dbg)
		love.graphics.clear()
	love.graphics.setCanvas()
	buffer.physics = {}
end


function drawing.keyreleased(key, _)
	if key == "c" then
		drawing.clearAllCanvases()
	end
	if key == "f" then
		love.graphics.setCanvas(buffer.pixel.fg)
		love.graphics.clear()
		for x = 0, world.x -drawing.currentCursor:getPixelWidth(),
			drawing.currentCursor:getPixelWidth() do
			for y = 0, world.y -drawing.currentCursor:getPixelHeight(),
				drawing.currentCursor:getPixelHeight() do
				love.graphics.draw(drawing.currentCursor, x, y)
			end
		end
		love.graphics.setCanvas()
	end
	if key == "b" then
		color_push()
		love.graphics.setCanvas(buffer.pixel.bg)
		love.graphics.clear()
		love.graphics.setColor(1, 1, 1, .6)
		for x = 0, world.x -drawing.currentCursor:getPixelWidth(),
			drawing.currentCursor:getPixelWidth() do
			for y = 0, world.y -drawing.currentCursor:getPixelHeight(),
				drawing.currentCursor:getPixelHeight() do
				love.graphics.draw(drawing.currentCursor, x, y)
			end
		end
		color_pop()
		love.graphics.setCanvas()
	end
end


function drawing.input(dt)
	local mousex = love.mouse.getX()
	local mousey = love.mouse.getY()
	if mousex > window.x -300 then return end
	if not love.mouse.isDown(2) and not love.mouse.isDown(1) then
		mouse.lastpos.x = nil
		mouse.lastpos.y = nil
		return
	end
	mousex = mousex / scale - view.x
	mousey = mousey / scale - view.y
	if mousex > world.x or
		mousey > world.y or
		mousex < 0 or
		mousey < 0 then
			return
	end

	color_push()
	local granularity = 1
	if mouse.lastpos.x and mouse.lastpos.y then
		local x = math.abs(mouse.lastpos.x - mousex)
		local y = math.abs(mouse.lastpos.y - mousey)
		granularity = math.sqrt(x * x + y * y) / 16
	else
		mouse.lastpos.x = mousex
		mouse.lastpos.y = mousey
	end
	if not granularity then granularity = 1 end
	for i=0,granularity,1 do
		local thisx = alignToGrid((((mouse.lastpos.x - mousex) / granularity) * i + mousex),
			drawing.currentCursor:getPixelWidth())
		local thisy = alignToGrid((((mouse.lastpos.y - mousey) / granularity) * i + mousey),
			drawing.currentCursor:getPixelHeight())
		if not thisx or not thisy then return end
		if not (thisx == thisx) or not (thisy == thisy) then return end

		local ctrlDown = love.keyboard.isDown("lctrl") or love.keyboard.isDown("rctrl")
		if ctrlDown then
			love.graphics.setColor(1, 1, 1, .6)
			love.graphics.setBlendMode("replace")
			love.graphics.setCanvas(buffer.pixel.bg)
		else
			love.graphics.setColor(1, 1, 1, 1)
			love.graphics.setCanvas(buffer.pixel.fg)
		end

		if love.mouse.isDown(1) then -- only delete
			love.graphics.draw(drawing.currentCursor, thisx, thisy)
			if not ctrlDown then
				physics.draw_solid(thisx, thisy,
					drawing.currentCursor:getPixelWidth(), drawing.currentCursor:getPixelHeight())
			end
		else
			love.graphics.setBlendMode("replace")
				love.graphics.setColor(0,0,0,0)
				love.graphics.rectangle("fill", thisx, thisy,
					drawing.currentCursor:getPixelWidth(), drawing.currentCursor:getPixelHeight())
			if not ctrlDown then
				physics.remove_solid(thisx, thisy,
					drawing.currentCursor:getPixelWidth(), drawing.currentCursor:getPixelHeight())
			end
		end
		love.graphics.setBlendMode("alpha")

		love.graphics.setCanvas()
	end
	color_pop()
	mouse.lastpos.x = mousex
	mouse.lastpos.y = mousey

	love.graphics.setCanvas()
end
