world = {}
world.x = 1024
world.y = 1024
--world.x = 6144
--world.y = 6144
framenum = 0

COLLISION_PRINT = false
PHYSICS_DEBUG = false

local socket = require "socket"
local address, port = "127.0.0.1", 42069

local client = socket.udp()
client:setpeername(address, port)

scale = 1

love.graphics.setDefaultFilter("nearest", "nearest", 0)
local w,h = love.window.getMode()


buffer = {}
  buffer.UI = love.graphics.newCanvas(w, h)
  buffer.pixel = {}
  buffer.pixel.fg = love.graphics.newCanvas(world.x, world.y)
  buffer.pixel.bg = love.graphics.newCanvas(world.x, world.y)
if COLLISION_PRINT then
  buffer.pixel.dbg = love.graphics.newCanvas(world.x, world.y)
  buffer.pixel.dbg2 = love.graphics.newCanvas(world.x, world.y)
end
  buffer.physics = {}
  buffer.programming = love.graphics.newCanvas(world.x, world.y)


layer = true

grid = 16
color = {}
mouse = {}
mouse.lastpos = {}
mouse.lastpos.x = 0
mouse.lastpos.y = 0

view = {}
view.x = 0
view.y = 0

window = {}
window.x, window.y = love.graphics.getDimensions()


player = {}
player.old =  {}
player.ava = love.graphics.newImage("textures/player/andysphinx/personb.png")
player.speed = {}
player.speed.x = 0
player.speed.y = 0
player.y = 16
player.x = 16

local networkChannel = love.thread.getChannel ( "network" );
function love.load()
	thread = love.thread.newThread( love.filesystem.newFileData( "lua/network.lua" ) )
	thread:start()
	client:send((record("poppyV001", unit("ID0", "rq", "cid"))))
	--canvas_clear()
	--draw_borders(brick[math.floor(love.math.random(1, #brick))])
	ui.init()
end


function love.resize()
	ui.resize()
	camera.resize()
end

function love.keyreleased(key, _)
	if PHYSICS_DEBUG then
		physics.keyreleased_debug(key, _)
	end
	camera.keyreleased(key, _)
	drawing.keyreleased(key, _)
end


local fullscreen = false
function love.keypressed(key, _)
	physics.keypressed(key, _)
	camera.keypressed(key, _)
end


function love.visible(visible)
	if visible then
		love.update = function(dt)
			camera.input(dt)
			physics.input(dt)
			drawing.input(dt)
			physics.update(dt)
			camera.update(dt)
		end
	else
		love.update = function(dt)
			physics.update(dt)
		end
	end
end


function normalDraw()
	local layerTransform = love.math.newTransform(math.floor(view.x) * scale, math.floor(view.y) * scale, 0, scale, scale)
	local playerTransform = love.math.newTransform(
		math.floor(player.x) * scale + math.floor(view.x) * scale,
		math.floor(player.y) * scale + math.floor(view.y) * scale,
		0, scale, scale)

	--draw specific world bg
	color_push()
	love.graphics.setColor(0.5, 0.0, 0.5)
	love.graphics.rectangle("fill", math.floor(view.x) * scale, math.floor(view.y) * scale, world.x * scale, world.y * scale)
	color_pop()

	-- Draw background
	love.graphics.draw(buffer.pixel.bg, layerTransform)

	-- draw player
	love.graphics.draw(player.ava, playerTransform)

	-- Draw foreground
	love.graphics.draw(buffer.pixel.fg, layerTransform)

	-- Draw UI
	love.graphics.draw(buffer.UI)
end


function debugDraw()
	normalDraw()
	local layerTransform = love.math.newTransform(math.floor(view.x) * scale, math.floor(view.y) * scale, 0, scale, scale)

	love.graphics.draw(buffer.pixel.dbg, layerTransform)
	love.graphics.draw(buffer.pixel.dbg2, layerTransform)

	love.graphics.setCanvas(buffer.pixel.dbg2)
		love.graphics.clear()
	love.graphics.setCanvas()
end


if not DEBUGPRINT then love.draw = normalDraw else
	love.draw = debugDraw
end

function love.threaderror(thread, errorString)
  print("Network error: " .. errorString)
end
